/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __ARCHIVE_H__
#define __ARCHIVE_H__

#include "arblkqueue.h"

struct s_dico;
struct s_arblkqueue;

struct s_archinfo
{
	int			archfd;
	u32			archid;
	int 			locked;
	struct s_arblkqueue	queue;
	int			terminate;
};

struct s_blockheader
{
	u8  magic[4]; 
	u64 blocksize;
	u64 blockoffset;
	u64 finalsize;
	u32 finalcsum;
	u32 compalgo;
} __attribute__ ((__packed__));

int archive_init(struct s_archinfo *ai);
int archive_destroy(struct s_archinfo *ai);
int archive_create(struct s_archinfo *ai, char *archive);
int archive_open(struct s_archinfo *ai, char *archive);
int archive_close(struct s_archinfo *ai);

#endif // __ARCHIVE_H__
