/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __EXTRACT_H__
#define __EXTRACT_H__

struct s_archinfo;
struct s_dico;

int restore_obj_hardlink(struct s_archinfo *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_symlink(struct s_archinfo *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_regfile(struct s_archinfo *ai, char *relpath, char *fullpath, char *destdir, struct s_dico *d);
int restore_obj_devfile(struct s_archinfo *ai, char *fullpath, char *destdir, struct s_dico *d);
int restore_object(struct s_archinfo *ai, int *errors, char *destdir, struct s_dico *dstd, struct s_dico *dxattr);
int extract_filesystem(struct s_archinfo *ai, char *partition);
int extract_read_objects(struct s_archinfo *ai, int *errors, char *destdir);
int do_extract(char *archive, char **partition);
int read_mainhead(struct s_archinfo *ai);

#endif // __EXTRACT_H__
