/*
 * fsarchiver: Filesystem Archiver
 *
 * Copyright (C) 2008 Francois Dupoux.  All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License v2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Homepage: http://www.fsarchiver.org
 */

#ifndef __FILEREADBUF_H__
#define __FILEREADBUF_H__

#define IMGREADBUF_BUFFER_SIZE		(DATA_MAX_BLOCK_SIZE*2)

struct s_filereadbuf
{
	char ringbuf[IMGREADBUF_BUFFER_SIZE];
	u64 filesize;
	int buflen; // how many valid data bytes are in the buffer
	u64 start; // file offset of the first byte which is in buffer
	int filefd; // file descriptor
	int eof; // true if eof reached
};

int filereadbuf_init(struct s_filereadbuf *frb, int fd);
int filereadbuf_eof(struct s_filereadbuf *frb);
int filereadbuf_compare(struct s_filereadbuf *frb, char *data, int len);
int filereadbuf_fill_buffer(struct s_filereadbuf *frb);
int filereadbuf_goto_next_pattern(struct s_filereadbuf *frb, char *pattern, int patlen);
int filereadbuf_read(struct s_filereadbuf *frb, void *buf, u64 size);
int filereadbuf_destroy(struct s_filereadbuf *frb);
int filereadbuf_read_nomove(struct s_filereadbuf *frb, void *buf, u64 size);
int filereadbuf_increase_position(struct s_filereadbuf *frb, u64 size);

#endif // __FILEREADBUF_H__
